﻿using HalconDotNet;
using System;
using System.Windows;
using System.Windows.Input;

namespace HSmartMultiTouch
{
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        // Display an image as soon as the HSmartWindowControlWPF has been initialized
        private void smartWindow_HInitWindow(object sender, EventArgs e)
        {
            // Display an image in the HSmartWindowControlWPF
            HImage img = new HImage("printer_chip/printer_chip_01");
            img.DispObj(smartWindow.HalconWindow);
            smartWindow.SetFullImagePart();
            smartWindow.HalconWindow.FlushBuffer();
        }

        #region Manipulation Touch Events
        // Variables to store the initial data
        int row1, col1, row2, col2, row, col;
        double widthControl, heightControl;
        private void smartWindow_ManipulationStarted(object sender, ManipulationStartedEventArgs e)
        {
            // Get the extents of the HSmartWindowControlWPF
            smartWindow.HalconWindow.GetPart(out row1, out col1, out row2, out col2);

            // Store the width and height of the control
            widthControl = smartWindow.ActualWidth;
            heightControl = smartWindow.ActualHeight;

            // Compute the Row and Column coordinates of the initial manipulation origin
            double x = e.ManipulationOrigin.X;
            double y = e.ManipulationOrigin.Y;

            row = (int)(row1 + (y / heightControl) * (row2 - row1));
            col = (int)(col1 + (x / widthControl) * (col2 - col1));
        }

        private void smartWindow_ManipulationDelta(object sender, ManipulationDeltaEventArgs e)
        {
            // Get manipulation data
            double x = e.ManipulationOrigin.X;
            double y = e.ManipulationOrigin.Y;
            double scale = e.CumulativeManipulation.Scale.X;

            // Compute new width of the part to be shown using the current scale
            double newHeight = (row2 - row1) / scale;
            double newWidth = (col2 - col1) / scale;

            // Compute new part limits originial image point (row, col) should be under the current manipulation origin
            double newRow1 = row - y/heightControl * newHeight;
            double newCol1 = col - x / widthControl * newWidth;
            double newRow2 = row + (1 - y / heightControl) * newHeight;
            double newCol2 = col + (1 - x / widthControl) * newWidth;
            
            // set the new part
            smartWindow.HalconWindow.SetPart(newRow1, newCol1, newRow2, newCol2);
        }
        #endregion
    }
}
